package howto;

import org.jboss.soa.esb.actions.AbstractFileAction;
import org.jboss.soa.esb.helpers.DomElement;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.Serializable;

import org.apache.log4j.xml.DOMConfigurator;
import org.jboss.soa.esb.listeners.GpListener;

public class MyFileWatcher extends AbstractFileAction
{
  static final String CONFIG_FILE = "BasicFileListenerConfig.xml";

  public MyFileWatcher(DomElement p_oP, Object p_oCurr) {
   super(p_oP, p_oCurr);		
  }
   	
  @Override
  public void processCurrentObject() throws Exception {    
    String message = readTextFile(getWorkFile()); 
    // getWorkFile() inherited from AbstractFileAction
    System.out.println("File Contents: \n" +  message + "\n\n");
  } 
	  
  public String readTextFile(File file) throws IOException 
  {
    StringBuffer sb = new StringBuffer(1024);
    BufferedReader reader = new BufferedReader(new FileReader(file.getPath()));
    char[] chars = new char[1];
    while( (reader.read(chars)) > -1){
       sb.append(String.valueOf(chars)); 
       chars = new char[1];
    }
    reader.close();
    return sb.toString();
  }

  @Override
  public Serializable getOkNotification() {
   return "OK NOTIFICATION: " + this.getClass();
  }

  @Override
  public Serializable getErrorNotification() {
   return "ERR NOTIFICATION: " + this.getClass();
  }

  	
  public static void main(String[] args) throws Exception
  {
    DOMConfigurator.configure("log4j.xml");
    GpListener oProc = new GpListener(CONFIG_FILE);
    oProc.run();
  }

} // class
